import networkx as nx
import matplotlib.pyplot as plt

def transitive_closure(G: nx.DiGraph):
    V = G.number_of_nodes()
    L = list(G.nodes)
    L.sort()
    T = [[None for j in range(V)] for i in range(V)]
    for i in range(V):
        for j in range(V):
            if L[i] == L[j] or G.has_edge(L[i],L[j]):
                T[i][j] = 1
            else:
                T[i][j] = 0

    for k in range(V):
        for i in range(V):
            for j in range(V):
                T[i][j] = T[i][j] or (T[i][k] and T[k][j])
    return(zip(L,T))

